/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import './stencil.core';


import {
  Argument,
} from './interfaces/Argument';
import {
  EventDefinition,
} from './interfaces/EventDefinition';
import {
  PropDefinition,
} from './interfaces/PropDefinition';
import {
  UsageMap,
} from './interfaces/UsageMap';


export namespace Components {

  interface AdApiName {}
  interface AdApiNameAttributes extends StencilHTMLAttributes {}

  interface AdApp {
    /**
    * The layout of the app. Possible values are: `"default"`, `"fluid"`.
    */
    'layout': 'default' | 'fluid';
  }
  interface AdAppAttributes extends StencilHTMLAttributes {
    /**
    * The layout of the app. Possible values are: `"default"`, `"fluid"`.
    */
    'layout'?: 'default' | 'fluid';
  }

  interface AdArgDef {
    'arg': Argument;
  }
  interface AdArgDefAttributes extends StencilHTMLAttributes {
    'arg'?: Argument;
  }

  interface AdButton {
    /**
    * The button context Options are: `"primary"`, `"neutral"`, "success"`, `"danger"`, and `"link"`.      *
    */
    'context': string;
    /**
    * Can the user interact with the button?
    */
    'disabled': boolean;
    /**
    * Contains a URL or a URL fragment that the hyperlink points to. Should not be used in Angular most likely
    */
    'href'?: string;
    /**
    * The button size. Possible values are: `"small"`, `"default"`, `"large"`.
    */
    'size'?: 'small' | 'default' | 'large';
    /**
    * The type of the button matching the native button types. Possible values are: `"submit"`, `"reset"` and `"button"`. Default value is: `"button"`
    */
    'type': 'submit' | 'reset' | 'button';
  }
  interface AdButtonAttributes extends StencilHTMLAttributes {
    /**
    * The button context Options are: `"primary"`, `"neutral"`, "success"`, `"danger"`, and `"link"`.      *
    */
    'context'?: string;
    /**
    * Can the user interact with the button?
    */
    'disabled'?: boolean;
    /**
    * Contains a URL or a URL fragment that the hyperlink points to. Should not be used in Angular most likely
    */
    'href'?: string;
    /**
    * Fires when the button is blurred
    */
    'onAdBlur'?: (event: CustomEvent<void>) => void;
    /**
    * Fires when the button is focused
    */
    'onAdFocus'?: (event: CustomEvent<void>) => void;
    /**
    * The button size. Possible values are: `"small"`, `"default"`, `"large"`.
    */
    'size'?: 'small' | 'default' | 'large';
    /**
    * The type of the button matching the native button types. Possible values are: `"submit"`, `"reset"` and `"button"`. Default value is: `"button"`
    */
    'type'?: 'submit' | 'reset' | 'button';
  }

  interface AdContainer {}
  interface AdContainerAttributes extends StencilHTMLAttributes {}

  interface AdDecorator {}
  interface AdDecoratorAttributes extends StencilHTMLAttributes {}

  interface AdEventDef {
    /**
    * The event to display
    */
    'event': EventDefinition;
  }
  interface AdEventDefAttributes extends StencilHTMLAttributes {
    /**
    * The event to display
    */
    'event'?: EventDefinition;
  }

  interface AdFooter {}
  interface AdFooterAttributes extends StencilHTMLAttributes {}

  interface AdHeader {
    /**
    * The library github repo
    */
    'github'?: string;
    /**
    * The current version of the library
    */
    'version'?: string;
  }
  interface AdHeaderAttributes extends StencilHTMLAttributes {
    /**
    * The library github repo
    */
    'github'?: string;
    /**
    * The current version of the library
    */
    'version'?: string;
  }

  interface AdInputDef {
    /**
    * The property to display
    */
    'input': PropDefinition;
  }
  interface AdInputDefAttributes extends StencilHTMLAttributes {
    /**
    * The property to display
    */
    'input'?: PropDefinition;
  }

  interface AdMarkdown {
    /**
    * The markdown string to parse
    */
    'data': string;
  }
  interface AdMarkdownAttributes extends StencilHTMLAttributes {
    /**
    * The markdown string to parse
    */
    'data'?: string;
  }

  interface AdMethodDef {
    /**
    * The property to display
    */
    'method': PropDefinition;
  }
  interface AdMethodDefAttributes extends StencilHTMLAttributes {
    /**
    * The property to display
    */
    'method'?: PropDefinition;
  }

  interface AdNavItem {}
  interface AdNavItemAttributes extends StencilHTMLAttributes {}

  interface AdNavToggle {
    /**
    * Whether the nav is active or not.
    */
    'active': boolean;
    /**
    * Disable the nav regardless of active state
    */
    'disabled': boolean;
  }
  interface AdNavToggleAttributes extends StencilHTMLAttributes {
    /**
    * Whether the nav is active or not.
    */
    'active'?: boolean;
    /**
    * Disable the nav regardless of active state
    */
    'disabled'?: boolean;
  }

  interface AdNav {
    /**
    * Whether the nav is active or not.
    */
    'active': boolean;
    /**
    * Disable the nav regardless of active state
    */
    'disabled': boolean;
  }
  interface AdNavAttributes extends StencilHTMLAttributes {
    /**
    * Whether the nav is active or not.
    */
    'active'?: boolean;
    /**
    * Disable the nav regardless of active state
    */
    'disabled'?: boolean;
  }

  interface AdOutputDef {
    /**
    * The property to display
    */
    'output': PropDefinition;
  }
  interface AdOutputDefAttributes extends StencilHTMLAttributes {
    /**
    * The property to display
    */
    'output'?: PropDefinition;
  }

  interface AdPropDef {
    /**
    * The property to display
    */
    'prop': PropDefinition;
  }
  interface AdPropDefAttributes extends StencilHTMLAttributes {
    /**
    * The property to display
    */
    'prop'?: PropDefinition;
  }

  interface AdRealTime {}
  interface AdRealTimeAttributes extends StencilHTMLAttributes {}

  interface AdToc {
    /**
    * The demo components
    */
    'demos': any[];
    /**
    * The object map of usa cases to their markdown
    */
    'docs': UsageMap;
  }
  interface AdTocAttributes extends StencilHTMLAttributes {
    /**
    * The demo components
    */
    'demos'?: any[];
    /**
    * The object map of usa cases to their markdown
    */
    'docs'?: UsageMap;
  }

  interface AdTypeDef {}
  interface AdTypeDefAttributes extends StencilHTMLAttributes {}
}

declare global {
  interface StencilElementInterfaces {
    'AdApiName': Components.AdApiName;
    'AdApp': Components.AdApp;
    'AdArgDef': Components.AdArgDef;
    'AdButton': Components.AdButton;
    'AdContainer': Components.AdContainer;
    'AdDecorator': Components.AdDecorator;
    'AdEventDef': Components.AdEventDef;
    'AdFooter': Components.AdFooter;
    'AdHeader': Components.AdHeader;
    'AdInputDef': Components.AdInputDef;
    'AdMarkdown': Components.AdMarkdown;
    'AdMethodDef': Components.AdMethodDef;
    'AdNavItem': Components.AdNavItem;
    'AdNavToggle': Components.AdNavToggle;
    'AdNav': Components.AdNav;
    'AdOutputDef': Components.AdOutputDef;
    'AdPropDef': Components.AdPropDef;
    'AdRealTime': Components.AdRealTime;
    'AdToc': Components.AdToc;
    'AdTypeDef': Components.AdTypeDef;
  }

  interface StencilIntrinsicElements {
    'ad-api-name': Components.AdApiNameAttributes;
    'ad-app': Components.AdAppAttributes;
    'ad-arg-def': Components.AdArgDefAttributes;
    'ad-button': Components.AdButtonAttributes;
    'ad-container': Components.AdContainerAttributes;
    'ad-decorator': Components.AdDecoratorAttributes;
    'ad-event-def': Components.AdEventDefAttributes;
    'ad-footer': Components.AdFooterAttributes;
    'ad-header': Components.AdHeaderAttributes;
    'ad-input-def': Components.AdInputDefAttributes;
    'ad-markdown': Components.AdMarkdownAttributes;
    'ad-method-def': Components.AdMethodDefAttributes;
    'ad-nav-item': Components.AdNavItemAttributes;
    'ad-nav-toggle': Components.AdNavToggleAttributes;
    'ad-nav': Components.AdNavAttributes;
    'ad-output-def': Components.AdOutputDefAttributes;
    'ad-prop-def': Components.AdPropDefAttributes;
    'ad-real-time': Components.AdRealTimeAttributes;
    'ad-toc': Components.AdTocAttributes;
    'ad-type-def': Components.AdTypeDefAttributes;
  }


  interface HTMLAdApiNameElement extends Components.AdApiName, HTMLStencilElement {}
  var HTMLAdApiNameElement: {
    prototype: HTMLAdApiNameElement;
    new (): HTMLAdApiNameElement;
  };

  interface HTMLAdAppElement extends Components.AdApp, HTMLStencilElement {}
  var HTMLAdAppElement: {
    prototype: HTMLAdAppElement;
    new (): HTMLAdAppElement;
  };

  interface HTMLAdArgDefElement extends Components.AdArgDef, HTMLStencilElement {}
  var HTMLAdArgDefElement: {
    prototype: HTMLAdArgDefElement;
    new (): HTMLAdArgDefElement;
  };

  interface HTMLAdButtonElement extends Components.AdButton, HTMLStencilElement {}
  var HTMLAdButtonElement: {
    prototype: HTMLAdButtonElement;
    new (): HTMLAdButtonElement;
  };

  interface HTMLAdContainerElement extends Components.AdContainer, HTMLStencilElement {}
  var HTMLAdContainerElement: {
    prototype: HTMLAdContainerElement;
    new (): HTMLAdContainerElement;
  };

  interface HTMLAdDecoratorElement extends Components.AdDecorator, HTMLStencilElement {}
  var HTMLAdDecoratorElement: {
    prototype: HTMLAdDecoratorElement;
    new (): HTMLAdDecoratorElement;
  };

  interface HTMLAdEventDefElement extends Components.AdEventDef, HTMLStencilElement {}
  var HTMLAdEventDefElement: {
    prototype: HTMLAdEventDefElement;
    new (): HTMLAdEventDefElement;
  };

  interface HTMLAdFooterElement extends Components.AdFooter, HTMLStencilElement {}
  var HTMLAdFooterElement: {
    prototype: HTMLAdFooterElement;
    new (): HTMLAdFooterElement;
  };

  interface HTMLAdHeaderElement extends Components.AdHeader, HTMLStencilElement {}
  var HTMLAdHeaderElement: {
    prototype: HTMLAdHeaderElement;
    new (): HTMLAdHeaderElement;
  };

  interface HTMLAdInputDefElement extends Components.AdInputDef, HTMLStencilElement {}
  var HTMLAdInputDefElement: {
    prototype: HTMLAdInputDefElement;
    new (): HTMLAdInputDefElement;
  };

  interface HTMLAdMarkdownElement extends Components.AdMarkdown, HTMLStencilElement {}
  var HTMLAdMarkdownElement: {
    prototype: HTMLAdMarkdownElement;
    new (): HTMLAdMarkdownElement;
  };

  interface HTMLAdMethodDefElement extends Components.AdMethodDef, HTMLStencilElement {}
  var HTMLAdMethodDefElement: {
    prototype: HTMLAdMethodDefElement;
    new (): HTMLAdMethodDefElement;
  };

  interface HTMLAdNavItemElement extends Components.AdNavItem, HTMLStencilElement {}
  var HTMLAdNavItemElement: {
    prototype: HTMLAdNavItemElement;
    new (): HTMLAdNavItemElement;
  };

  interface HTMLAdNavToggleElement extends Components.AdNavToggle, HTMLStencilElement {}
  var HTMLAdNavToggleElement: {
    prototype: HTMLAdNavToggleElement;
    new (): HTMLAdNavToggleElement;
  };

  interface HTMLAdNavElement extends Components.AdNav, HTMLStencilElement {}
  var HTMLAdNavElement: {
    prototype: HTMLAdNavElement;
    new (): HTMLAdNavElement;
  };

  interface HTMLAdOutputDefElement extends Components.AdOutputDef, HTMLStencilElement {}
  var HTMLAdOutputDefElement: {
    prototype: HTMLAdOutputDefElement;
    new (): HTMLAdOutputDefElement;
  };

  interface HTMLAdPropDefElement extends Components.AdPropDef, HTMLStencilElement {}
  var HTMLAdPropDefElement: {
    prototype: HTMLAdPropDefElement;
    new (): HTMLAdPropDefElement;
  };

  interface HTMLAdRealTimeElement extends Components.AdRealTime, HTMLStencilElement {}
  var HTMLAdRealTimeElement: {
    prototype: HTMLAdRealTimeElement;
    new (): HTMLAdRealTimeElement;
  };

  interface HTMLAdTocElement extends Components.AdToc, HTMLStencilElement {}
  var HTMLAdTocElement: {
    prototype: HTMLAdTocElement;
    new (): HTMLAdTocElement;
  };

  interface HTMLAdTypeDefElement extends Components.AdTypeDef, HTMLStencilElement {}
  var HTMLAdTypeDefElement: {
    prototype: HTMLAdTypeDefElement;
    new (): HTMLAdTypeDefElement;
  };

  interface HTMLElementTagNameMap {
    'ad-api-name': HTMLAdApiNameElement
    'ad-app': HTMLAdAppElement
    'ad-arg-def': HTMLAdArgDefElement
    'ad-button': HTMLAdButtonElement
    'ad-container': HTMLAdContainerElement
    'ad-decorator': HTMLAdDecoratorElement
    'ad-event-def': HTMLAdEventDefElement
    'ad-footer': HTMLAdFooterElement
    'ad-header': HTMLAdHeaderElement
    'ad-input-def': HTMLAdInputDefElement
    'ad-markdown': HTMLAdMarkdownElement
    'ad-method-def': HTMLAdMethodDefElement
    'ad-nav-item': HTMLAdNavItemElement
    'ad-nav-toggle': HTMLAdNavToggleElement
    'ad-nav': HTMLAdNavElement
    'ad-output-def': HTMLAdOutputDefElement
    'ad-prop-def': HTMLAdPropDefElement
    'ad-real-time': HTMLAdRealTimeElement
    'ad-toc': HTMLAdTocElement
    'ad-type-def': HTMLAdTypeDefElement
  }

  interface ElementTagNameMap {
    'ad-api-name': HTMLAdApiNameElement;
    'ad-app': HTMLAdAppElement;
    'ad-arg-def': HTMLAdArgDefElement;
    'ad-button': HTMLAdButtonElement;
    'ad-container': HTMLAdContainerElement;
    'ad-decorator': HTMLAdDecoratorElement;
    'ad-event-def': HTMLAdEventDefElement;
    'ad-footer': HTMLAdFooterElement;
    'ad-header': HTMLAdHeaderElement;
    'ad-input-def': HTMLAdInputDefElement;
    'ad-markdown': HTMLAdMarkdownElement;
    'ad-method-def': HTMLAdMethodDefElement;
    'ad-nav-item': HTMLAdNavItemElement;
    'ad-nav-toggle': HTMLAdNavToggleElement;
    'ad-nav': HTMLAdNavElement;
    'ad-output-def': HTMLAdOutputDefElement;
    'ad-prop-def': HTMLAdPropDefElement;
    'ad-real-time': HTMLAdRealTimeElement;
    'ad-toc': HTMLAdTocElement;
    'ad-type-def': HTMLAdTypeDefElement;
  }


}
